/**
 * Copyright (c) 2013 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/lambda3/).
 */
package org.xmloperator.lambda3.impl;

import org.xmloperator.lambda3.exception.IllegalFunctionArgumentException;
import org.xmloperator.lambda3.model.Function1;
import org.xmloperator.lambda3.model.NumberCoding;
import org.xmloperator.lambda3.model.Term;

/**
 * Function that maps to a float value.
 */
final class FunctionFloat implements Function1 {
	final double floatValue;
	
	FunctionFloat(double floatValue) {
		this.floatValue = floatValue;
	}
	
	//////////////////////////
	// Function implementation
	//////////////////////////

	public String getName() {
		return NumberCoding.FLOAT + String.valueOf(this.floatValue);
	}
	
	public boolean acceptArgument(int index, Term arg) {
		return false;
	}
	
	///////////////////////////
	// Function1 implementation
	///////////////////////////
	
	public Term function(Term arg) {
		throw new IllegalFunctionArgumentException(this, arg);
	}
}
