package org.xmloperator.lambda3.impl.type;

import java.util.List;

import org.xmloperator.lambda3.exception.type.UntypableTermException;
import org.xmloperator.lambda3.model.type.ConstantTermType;
import org.xmloperator.lambda3.model.type.TermType;

final class ConstantTermTypeImpl extends TermTypeImpl implements
		ConstantTermType {
	final char constantTypeChar;

	ConstantTermTypeImpl(char constantTypeChar) {
		if (constantTypeChar == 0)
			throw new IllegalArgumentException();
		this.constantTypeChar = constantTypeChar;
	}

	//////////////////////////////////
	// ConstantTermType implementation
	//////////////////////////////////
	
	public char getConstantTypeChar() {
		return this.constantTypeChar;
	}

	//////////////////////////
	// TermType implementation
	//////////////////////////
	
	public boolean isConstantTermType() {
		return true;
	}
	
	public void setEquivalence(TermType replacement) {
		replacement = replacement.getTerminalType();
		if (replacement == this)
			return;
		if (replacement.isVariableTermType()) {
			replacement.setEquivalence(this);
			return;
		}
		throw new UntypableTermException();
	}

	////////////////////////
	// TermTypeImpl override
	////////////////////////
	
	void toString(StringBuffer sb, List<TermType> terminalList) {
		sb.append(this.constantTypeChar);
	}
}
