/**
 * Copyright (c) 2013 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/lambda3/).
 */
package org.xmloperator.lambda3.impl.type;

import java.util.ArrayList;
import java.util.List;

import org.xmloperator.lambda3.model.type.TermType;

/**
 * Abstract implementation of TermType.
 */
abstract class TermTypeImpl implements TermType {
	
	/**
	 * Constructs a String representation of this TermType.
	 * 
	 * @param sb
	 *            a StringBuffer for construction.
	 * @param terminalList
	 *            a list of terminal TermType.
	 */
	abstract void toString(StringBuffer sb, List<TermType> terminalList);

	// ///////////////////////
	// TermType implementation
	// ///////////////////////

	public boolean isVariableTermType() {
		return false;
	}
	
	public boolean isFunctionTermType() {
		return false;
	}

	public boolean isConstantTermType() {
		return false;
	}
	
	public boolean isTerminal() {
		return true;
	}

	public TermType getTerminalType() {
		return this;
	}

	public boolean isUsing(TermType termType) {
		return this == termType;
	}

	public final String toString() {
		StringBuffer sb = new StringBuffer();
		this.toString(sb, new ArrayList<TermType>());
		return sb.toString();
	}
}
