/**
 * Copyright (c) 2013 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/lambda3/).
 */
package org.xmloperator.lambda3.model;

/**
 * Constant function.
 */
public interface Function {

	/**
	 * Returns the name of this Function.
	 * <p>
	 * It is used as "predefined identifier" if between "A" and "Z".
	 * </p>
	 * 
	 * @return the name of this Function.
	 */
	public String getName();

	/**
	 * Returns <tt>true</tt> if this Function would accept the given argument at
	 * the given index.
	 * 
	 * @param index
	 *            the argument index (from 0).
	 * @param arg
	 *            an argument.
	 * @return <tt>true</tt> if this Function would accept the given argument at
	 *         the given index.
	 */
	public boolean acceptArgument(int index, Term arg);
}
