/**
 * Copyright (c) 2013 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/lambda3/).
 */
package org.xmloperator.lambda3.model;

/**
 * Informant about reductions on a Term.
 */
public interface InformantReduction {
	public static final char CHAR_REDUCTION_START = 's';
	public static final char CHAR_REDUCTION_BETA = 'b';
	public static final char CHAR_REDUCTION_DELTA = 'd';
	public static final char CHAR_REDUCTION_ETA = 't';

	/**
	 * Informs about the last reduction on a Term.
	 * @param reductionType
	 *            the type of reduction that leads to the given Term.
	 * @param rootTerm
	 *            the obtained rout Term.
	 * @param redex
	 *            the outermost-leftermost redex of this root Term, if any.
	 */
	public void inform(char reductionType, Term rootTerm, Application redex);
}
