/**
 * Copyright (c) 2013 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/lambda3/).
 */
package org.xmloperator.lambda3.util;

/**
 * Reservable resource.
 */
public interface Reservable<T> {

	/**
	 * Reserves the resource and gets it.
	 * 
	 * @param <T>
	 *            the resource type.
	 * @return the reserved resource.
	 * @throws AlreadyUsedResourceException
	 *             if the resource is already used.
	 */
	public T reserve();

	/**
	 * Makes the resource back.
	 */
	public void makeBack();
}
